# coding: utf-8

"""
    Open Agent API

    API for interacting with AI agents

    The version of the OpenAPI document: 0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from open_agent_api.models.message import Message
from typing import Optional, Set
from typing_extensions import Self

class AgentCompletionChunk(BaseModel):
    """
    AgentCompletionChunk
    """ # noqa: E501
    content: Optional[StrictStr] = Field(default=None, description="The content of the chunk")
    content_type: StrictStr = Field(description="The type of the content")
    event: StrictStr = Field(description="The event")
    model: StrictStr = Field(description="The model")
    run_id: StrictStr = Field(description="The run id")
    agent_id: StrictStr = Field(description="The agent id")
    session_id: StrictStr = Field(description="The session id")
    created_at: StrictInt = Field(description="The created at timestamp")
    tools: Optional[List[Dict[str, Any]]] = Field(default=None, description="Tool executions in the run (for RunStarted and RunCompleted events)")
    messages: Optional[List[Message]] = Field(default=None, description="Messages in the run (for RunStarted and RunCompleted events)")
    __properties: ClassVar[List[str]] = ["content", "content_type", "event", "model", "run_id", "agent_id", "session_id", "created_at", "tools", "messages"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of AgentCompletionChunk from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in messages (list)
        _items = []
        if self.messages:
            for _item_messages in self.messages:
                if _item_messages:
                    _items.append(_item_messages.to_dict())
            _dict['messages'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of AgentCompletionChunk from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "content": obj.get("content"),
            "content_type": obj.get("content_type"),
            "event": obj.get("event"),
            "model": obj.get("model"),
            "run_id": obj.get("run_id"),
            "agent_id": obj.get("agent_id"),
            "session_id": obj.get("session_id"),
            "created_at": obj.get("created_at"),
            "tools": obj.get("tools"),
            "messages": [Message.from_dict(_item) for _item in obj["messages"]] if obj.get("messages") is not None else None
        })
        return _obj


